#name: tengine_install.sh
#Preconditions: Local source

Architecture=`lscpu |grep Architecture | awk '{print $2}'`

function TengineInstallStart(){
        #create the install status directory
        StatusDir=/var/log/
        StatusFile=$StatusDir/install.log
        if [ ! -d "$StatusDir" ]; then
            mkdir -p $StatusDir
        fi
        touch $StatusFile
        echo "install running" > $StatusFile
}

function TengineYumInstall(){
        #install dependency package
        #set -e
        yum install wget zip unzip tar coreutils  krb5-devel pcre pcre-devel sed rpm-build gcc gcc-c++  make libtool zlib zlib-devel perl* expect openssl*  -y  >> $StatusFile 2>&1
        if [ $? -ne 0 ];then
          echo "install error" >> $StatusFile
                echo "yum error!" | tee -a $StatusFile
                exit 1
        fi
}

function TengineDepencyInstall(){
       if [ "$(printf '%s\n' "1.1.1a" "`openssl version  | awk '{print $2}'`" | sort -V | head -n1)" = "1.1.1a" ];then
             return 1;
       fi

        #check and install openssl
        if [ ! -f openssl-libs-1.1.1a-3.el7.$Architecture.rpm ] || [ ! -f openssl-1.1.1a-3.el7.$Architecture.rpm ] || [ ! -f openssl-devel-1.1.1a-3.el7.$Architecture.rpm ];then
                echo "install error" >> $StatusFile
                echo "please put the openssl rpm in the folder"
                exit 1
        fi

        rpm -ivh openssl-libs-1.1.1a-3.el7.$Architecture.rpm openssl-1.1.1a-3.el7.$Architecture.rpm openssl-devel-1.1.1a-3.el7.$Architecture.rpm --force --nodeps  >> $StatusFile 2>&1
        if [ $? -ne 0 ];then
                echo "install error" >> $StatusFile
                echo "deploy openssl failed!" | tee -a $StatusFile
                exit 1
        fi

        echo $PATH | grep "/usr/local/bin" > /dev/null
        if [ $? -ne 0 ];then
            echo export PATH=/usr/local/bin:\$PATH >> /etc/profile
            source /etc/profile
        fi

        cat /etc/ld.so.conf | grep "/usr/local/lib/" > /dev/null
        if [ $? -ne 0 ];then
            echo /usr/local/lib/  >> /etc/ld.so.conf
        fi

        cat /etc/ld.so.conf | grep "/usr/local/lib64/" > /dev/null
        if [ $? -ne 0 ];then
            echo /usr/local/lib64/  >> /etc/ld.so.conf
        fi

        cat /etc/ld.so.conf | grep "/usr/local/lib64/" > /dev/null
        if [ $? -ne 0 ];then
            echo /usr/local/lib64/  >> /etc/ld.so.conf
        fi

        ldconfig -v  >> $StatusFile 2>&1
        openssl version  >> $StatusFile 2>&1
}

function TengineRpmInstall(){
        #check and install tengine
        rpm -qa | grep tengine-2.2.2 >> $StatusFile 2>&1
        if [ $? -ne 1 ];then
                rpm -e --nodeps `rpm -qa |grep tengine-2.2.2`
        fi
        #start to install the rpm to /usr/local/tengine-nginx
        rpm -ivh tengine-2.2.2*.$Architecture.rpm  >> $StatusFile 2>&1
        if [ $? -ne 0 ];then
                echo "install error" >> $StatusFile
                echo "rpm install error!" | tee -a $StatusFile
                exit 1
        fi
        ls /usr/local/tengine-nginx  >> $StatusFile 2>&1
}

function TengineInstallStop(){
        echo "$subUnit install success" | tee -a $StatusFile
}

TengineInstallStart
TengineYumInstall
TengineDepencyInstall
TengineRpmInstall
TengineInstallStop
