#!/bin/bash

#
#    回退nginx的编译，安装，部署和调优
#

function RollbackGerneral(){
    rm -rf /etc/modprobe.d/blacklist.conf
    sed -i "/* soft    nofile  102400/d" /etc/security/limits.conf
    sed -i "/* hard    nofile  102400/d" /etc/security/limits.conf
    \cp -rf /etc/sysctl.conf_bak /etc/sysctl.conf
    sed -i 's/SELINUX=disabled/SELINUX=enforcing/g' /etc/sysconfig/selinux
    sed -i 's/iommu.passthrough=1/ /g' /etc/grub2-efi.cfg
}

function RollBacKNginx(){
    pkill nginx
        rpm -qa | grep tengine-2.2.2
        if [ $? -ne 1 ];then
                rpm -e --nodeps `rpm -qa |grep tengine-2.2.2`
        fi
    rm -rf /usr/local/tengine-nginx
    \cp -rf /etc/profile_bak /etc/profile
        rm -rf ./deps/tengine-2.2.2-1.el7_4.aarch64.rpm ./deps/tengine-debuginfo-2.2.2-1.el7_4.aarch64.rpm
}

function RollBackDependency(){
        rpm -qa |grep openssl-1.1.1a
        if [ $? -ne 1 ];then
                rpm -e --nodeps openssl-libs-1.1.1a openssl-1.1.1a openssl-devel-1.1.1a
        fi
        cd ./deps
        rm -rf openssl-libs-1.1.1a-3.el7.aarch64.rpm  openssl-1.1.1a-3.el7.aarch64.rpm  openssl-devel-1.1.1a-3.el7.aarch64.rpm \
        openssl-debuginfo-1.1.1a-3.el7.aarch64.rpm
        sed -i  '/export PATH=\/usr\/local\/bin:$PATH/d' /etc/profile
        sed -i  '/systemctl start irqbalance.service/d' /etc/profile
        sed -i  '/systemctl stop irqbalance.service/d' /etc/profile
        sed -i  '/irq_default.sh/d' /etc/profile
        sed -i  '/eth/d' /etc/profile
        sed  -i '/\/usr\/local\/lib\//d' /etc/ld.so.conf
}

#-----------------shell begin--------------------
echo "begin to rollback"
RollbackGerneral
RollBacKNginx
RollBackDependency
echo "roll back success, you need to reboot to make the rollback work"

